/* This file contains prototypes for the functions in callbacks.c.  It is
 * included by main.c so that when you create a new widget, you can tie
 * its callback function to something that has been defined (otherwise the
 * compiler will give you and error).
 *
 * If you add any functions to callbacks.c, you should put a corresponding 
 * function prototype in here.
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"


/* animation time increments */
//#define T_INC 0.03
#define T_INC 0.01
#define T_DELAY 0


/* callback protos */
void quit(Widget w,    void *data);
/*void button1(Widget w, void *data); 
void button2(Widget w, void *data);*/
void play_anim(Widget w, void *data);
void rewind_anim(Widget w, void *data);
void stop_anim(Widget w, void *data);
void forward_anim(Widget w, void *data);
void repeat_anim(Widget w, void *data);

void scroll(Widget w, float new_value, void *data);
void redisplay(Widget w, int new_width, int new_height, void *data);
void button_down(Widget w, int which_button, int x,int y, void *data);
void button_up(Widget w, int which_button, int x, int y, void *data);
void keypress(Widget w, char *input, int up_or_down, void *data);
void motion(Widget w, int x, int y, void *data);

void animate(caddr_t *data, XtIntervalId *id);


//int Distance(int, int, int, int);
//void CalculateEffect(Blob *blob1, Blob *blob2);
//void DrawBlob(Blob *);
//void Blit(unsigned char *dest, unsigned char *src, int dx, int dy, 
//	  int dcols, int drows, int scols, int srows);
void DrawBlobs(unsigned char *image, int x0, int y0, int x1, int y1, int cols, int rows);




