#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "graphics.h"
#include "hair.h"

void AddCameraToHair( Camera *camera, Hair *hair );

extern Camera *camera;

float wind = 0.8;

int GetJointColor( Strand *strand, int joint_num ){
	int color;
	float nx, ny, nz;
	int i;
	float magnitude;

	float facing[ WIDTH_SEGMENTS ];
	float dot = 0.0;
	int num_facing = 0;

	for(i=0; i<WIDTH_SEGMENTS; ++i ){
		nx = (strand->joints[ joint_num ].points[ i ].y-strand->joints[ joint_num + 1 ].points[ i  ].y)
			*(strand->joints[ joint_num ].points[ i ].z+strand->joints[ joint_num + 1 ].points[ i ].z);

		ny = (strand->joints[ joint_num ].points[ i ].z-strand->joints[ joint_num + 1 ].points[ i ].z)
			*(strand->joints[ joint_num ].points[ i ].x+strand->joints[ joint_num + 1 ].points[ i ].x);

		nz = (strand->joints[ joint_num ].points[ i ].x-strand->joints[ joint_num + 1 ].points[ i ].x)
			*(strand->joints[ joint_num ].points[ i ].y+strand->joints[ joint_num + 1 ].points[ i ].y);


		nx += (strand->joints[ joint_num + 1 ].points[ i ].y-strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].y)
			*(strand->joints[ joint_num + 1 ].points[ i ].z+strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].z);

		ny += (strand->joints[ joint_num + 1 ].points[ i ].z-strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].z)
			*(strand->joints[ joint_num + 1 ].points[ i ].x+strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].x);

		nz += (strand->joints[ joint_num + 1 ].points[ i ].x-strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].x)
			*(strand->joints[ joint_num + 1 ].points[ i ].y+strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].y);


		nx += (strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].y-strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].y)
			*(strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].z+strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].z);

		ny += (strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].z-strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].z)
			*(strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].x+strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].x);

		nz += (strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].x-strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].x)
			*(strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].y+strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].y);


		nx += (strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].y-strand->joints[ joint_num ].points[ i ].y)
			*(strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].z+strand->joints[ joint_num ].points[ i ].z);

		ny += (strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].z-strand->joints[ joint_num ].points[ i ].z)
			*(strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].x+strand->joints[ joint_num ].points[ i ].x);

		nz += (strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].x-strand->joints[ joint_num ].points[ i ].x)
			*(strand->joints[ joint_num ].points[ ((i+1)%WIDTH_SEGMENTS) ].y+strand->joints[ joint_num ].points[ i ].y);
                
/*
        	nx = (strand->joints[ joint_num ].points[ i ].y * strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].z) - 
			(strand->joints[ joint_num ].points[ i ].z * strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].y);

	        ny = (strand->joints[ joint_num ].points[ i ].z * strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].x) - 
			(strand->joints[ joint_num ].points[ i ].x * strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].z);

        	nz = (strand->joints[ joint_num ].points[ i ].x * strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].y) - 
			(strand->joints[ joint_num ].points[ i ].y * strand->joints[ joint_num + 1 ].points[ ((i+1)%WIDTH_SEGMENTS) ].x);
*/

	        magnitude = sqrt( SQR( nx ) + SQR( ny ) + SQR( nz ) );

        	if( magnitude != 0.0 ){
                	nx /= magnitude;
                	ny /= magnitude;
                	nz /= magnitude;
        	}

		if( nz < 0.0 ){
			facing[ num_facing++ ] = nz;
		}
	}

	for(i=0; i<num_facing; ++i ){
		dot += facing[ i ];
	}

	dot /= num_facing;

	color = 255 * dot;

	return( 255 );
} 

void DrawHair( Hair *hair, Camera *camera, Image *image ){
	int i, j, color;

	Clear( image );

	for(i=0; i<NUM_HAIRS; ++i ){
		for(j=0; j<LENGTH_SEGMENTS-1; ++j ){
			color = GetJointColor( &(hair->strands[i]), j );

			//AddCameraToHair( camera, hair );

			MyDrawLine( hair->strands[i].joints[j].x,
					(image->height-hair->strands[i].joints[j].y),
					hair->strands[i].joints[j+1].x, 
					(image->height-hair->strands[i].joints[j+1].y), color, image );
		}
	}
}


Hair *MakeHair( float x, float y, float z ){
  Hair *temp;
  float cx, cy, cz;
  long hair_num;
  long sqr_hairs = sqrt( NUM_HAIRS );

  temp = (Hair *)malloc( sizeof( Hair ) );

  temp->x = x;
  temp->y = y;
  temp->z = z;

  cx = x;
  cy = y;
  cz = z;

  for(hair_num=0; hair_num < NUM_HAIRS; hair_num++ ){
    MakeStrand( cx, cy, cz, &(temp->strands[ hair_num ]) );

    if( (hair_num%sqr_hairs) == 0 ){
      cz = z;
      cy += SPACING;// + (( 0.5 - ( rand() / (float)RAND_MAX ) ) / .1);
    }else{
      cz += SPACING;// + (( 0.5 - ( rand() / (float)RAND_MAX ) ) / .1);
    }

  }

  return( temp );
}

void MakeStrand( float x, float y, float z, Strand *temp ){
  float angle;
  long length_segment, width_segment;
  float cx, cy, cz;
  float y_factor;

  temp->x = x;
  temp->y = y;
  temp->z = z;

  for(length_segment=0; length_segment<LENGTH_SEGMENTS; ++length_segment ){
    cx = x + (float)(length_segment*NORMAL_LENGTH) + (( 0.5 - ( rand() / (float)RAND_MAX ) ) / .1);
    angle = 0.0;

    y_factor = (( 0.5 - ( rand() / (float)RAND_MAX ) ) / .1);

    temp->joints[ length_segment ].x = cx;
    temp->joints[ length_segment ].y = y + y_factor;
    temp->joints[ length_segment ].z = z;
    temp->joints[ length_segment ].vx = 0;
    temp->joints[ length_segment ].vy = GRAVITY;
    temp->joints[ length_segment ].vz = 0;

    if( length_segment == 0 ){
	    temp->joints[ length_segment ].fixed = 1;
    }else{
	    temp->joints[ length_segment ].fixed = 0;
    }

    for(width_segment=0; width_segment<WIDTH_SEGMENTS; ++width_segment ){
	if( length_segment == 0 ){
		cy = y + y_factor + ( RADIUS * sin( angle ) );
		cz = z + ( RADIUS * cos( angle ) );
	}
	else{
		cy = temp->joints[ 0 ].points[ width_segment ].y;
		cz = temp->joints[ 0 ].points[ width_segment ].z;
	}

      temp->joints[ length_segment ].points[ width_segment ].x = cx;
      temp->joints[ length_segment ].points[ width_segment ].y = cy;
      temp->joints[ length_segment ].points[ width_segment ].z = cz;

      angle += (2*PI)/(float)WIDTH_SEGMENTS;
    }
  }
}

void AnimateHair( Hair *hair, float t ){
	int i, j, k;
	float X_vector1, Y_vector1, Z_vector1;
	float Extension1, Magnitude1;
	float X_vector2, Y_vector2, Z_vector2;
	float Extension2, Magnitude2;
	float xv, yv, zv;
	float temp_amount;

	float wind_deflect;

	float 	center_x = hair->x,
		center_y = hair->y,
		center_z = hair->z;

	float dist, max_dist;
	float wind_power;

	max_dist =  sqrt( 	SQR( SPACING*sqrt(NUM_HAIRS) ) + 
				SQR( SPACING*sqrt(NUM_HAIRS) ) );

	for(k=0; k<NUM_HAIRS; ++k ){
		dist = sqrt( 	SQR( center_x - hair->strands[k].x ) + 
				SQR( center_y - hair->strands[k].y ) + 
				SQR( center_z - hair->strands[k].z ) );

		wind_power = dist / max_dist;

		wind_deflect = ( 0.5 - ( rand() / (float)RAND_MAX ) ) / 1.0;

		for(j=1; j<(LENGTH_SEGMENTS-1); ++j ){
			X_vector1 = hair->strands[k].joints[j-1].x - hair->strands[k].joints[j].x;
			Y_vector1 = hair->strands[k].joints[j-1].y - hair->strands[k].joints[j].y;
			Z_vector1 = hair->strands[k].joints[j-1].z - hair->strands[k].joints[j].z;
			Magnitude1 = sqrt( SQR( X_vector1 ) + SQR( Y_vector1 ) + SQR( Z_vector1 ) );
			Extension1 = Magnitude1 - NORMAL_LENGTH;
			
			X_vector2 = hair->strands[k].joints[j+1].x - hair->strands[k].joints[j].x;
			Y_vector2 = hair->strands[k].joints[j+1].y - hair->strands[k].joints[j].y;
			Z_vector2 = hair->strands[k].joints[j+1].z - hair->strands[k].joints[j].z;
			Magnitude2 = sqrt( SQR( X_vector2 ) + SQR( Y_vector2 ) + SQR( Z_vector2 ) );
			Extension2 = Magnitude2 - NORMAL_LENGTH;

			xv = ((X_vector1/Magnitude1)*Extension1) + ((X_vector2/Magnitude2)*Extension2) + ( wind * 0.5 ) + ( wind * 0.5 * wind_power );
			yv = ((Y_vector1/Magnitude1)*Extension1) + ((Y_vector2/Magnitude2)*Extension2) + GRAVITY;
			zv = ((Z_vector1/Magnitude1)*Extension1) + ((Z_vector2/Magnitude2)*Extension2) + wind_deflect;

			hair->strands[k].joints[j].vx = ( hair->strands[k].joints[j].vx * DAMPING ) + xv;
			hair->strands[k].joints[j].vy = ( hair->strands[k].joints[j].vy * DAMPING ) + yv;
			hair->strands[k].joints[j].vz = ( hair->strands[k].joints[j].vz * DAMPING ) + zv;
		}

		X_vector1 = hair->strands[k].joints[LENGTH_SEGMENTS-2].x - hair->strands[k].joints[LENGTH_SEGMENTS-1].x;
		Y_vector1 = hair->strands[k].joints[LENGTH_SEGMENTS-2].y - hair->strands[k].joints[LENGTH_SEGMENTS-1].y;
		Z_vector1 = hair->strands[k].joints[LENGTH_SEGMENTS-2].z - hair->strands[k].joints[LENGTH_SEGMENTS-1].z;
		Magnitude1 = sqrt( SQR( X_vector1 ) + SQR( Y_vector1 ) + SQR( Z_vector1) );
		Extension1 = Magnitude1 - NORMAL_LENGTH;

		xv = ((X_vector1/Magnitude1)*Extension1) + ( wind * 0.5 ) + ( wind * 0.5 * wind_power );
		yv = ((Y_vector1/Magnitude1)*Extension1) + GRAVITY;
		zv = ((Z_vector1/Magnitude1)*Extension1) + wind_deflect;

		hair->strands[k].joints[LENGTH_SEGMENTS-1].vx = ( hair->strands[k].joints[LENGTH_SEGMENTS-1].vx * DAMPING ) + xv;
		hair->strands[k].joints[LENGTH_SEGMENTS-1].vy = ( hair->strands[k].joints[LENGTH_SEGMENTS-1].vy * DAMPING ) + yv;
		hair->strands[k].joints[LENGTH_SEGMENTS-1].vz = ( hair->strands[k].joints[LENGTH_SEGMENTS-1].vz * DAMPING ) + zv;
	}


	for(k=0; k<NUM_HAIRS; ++k ){
		for(j=0; j<LENGTH_SEGMENTS; ++j ){
			if( hair->strands[k].joints[j].fixed != 1 ){
				hair->strands[k].joints[j].x = hair->strands[k].joints[j].x + ( hair->strands[k].joints[j].vx );
				hair->strands[k].joints[j].y = hair->strands[k].joints[j].y + ( hair->strands[k].joints[j].vy );
				hair->strands[k].joints[j].z = hair->strands[k].joints[j].z + ( hair->strands[k].joints[j].vz );

				if( hair->strands[k].joints[j].y < 10.0 ){
					temp_amount = 10.0 - hair->strands[k].joints[j].y;
					hair->strands[k].joints[j].y = 10.0;

					for(i=0; i<WIDTH_SEGMENTS; ++i ){
						hair->strands[k].joints[j].points[i].x = hair->strands[k].joints[j].points[i].x + hair->strands[k].joints[j].vx;
						hair->strands[k].joints[j].points[i].y = hair->strands[k].joints[j].points[i].y + temp_amount;
						hair->strands[k].joints[j].points[i].z = hair->strands[k].joints[j].points[i].z + hair->strands[k].joints[j].vz;
					}
				}else{
					for(i=0; i<WIDTH_SEGMENTS; ++i ){
						hair->strands[k].joints[j].points[i].x = hair->strands[k].joints[j].points[i].x + hair->strands[k].joints[j].vx;
						hair->strands[k].joints[j].points[i].y = hair->strands[k].joints[j].points[i].y + hair->strands[k].joints[j].vy;
						hair->strands[k].joints[j].points[i].z = hair->strands[k].joints[j].points[i].z + hair->strands[k].joints[j].vz;
					}
				}
			}
		}
	}

	wind += ( rand() / (float)RAND_MAX ) * sin( 1.3 * PI * t );

	if( wind < 0.0 ) wind = 0.0;
	if( wind > 5.0 ) wind = 5.0;
}

void OutputHair( char *filename, Hair *hair ){
	FILE *fp;
	long i, j, k;
	long count=0;

	fp = fopen( filename, "w" );

	for(i=0; i<NUM_HAIRS; ++i ){
		for(j=0; j<(LENGTH_SEGMENTS-1); ++j ){
			for(k=0; k<WIDTH_SEGMENTS; ++k ){
				count+=6;
				fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j].points[k].x,
							hair->strands[i].joints[j].points[k].y, 
							hair->strands[i].joints[j].points[k].z );
				fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j+1].points[k].x,
							hair->strands[i].joints[j+1].points[k].y, 
							hair->strands[i].joints[j+1].points[k].z );
				if( k != (WIDTH_SEGMENTS-1) ){
					fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j+1].points[k+1].x,
								hair->strands[i].joints[j+1].points[k+1].y, 
								hair->strands[i].joints[j+1].points[k+1].z );
				}else{
					fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j+1].points[0].x,
								hair->strands[i].joints[j+1].points[0].y, 
								hair->strands[i].joints[j+1].points[0].z );
				}
				if( k != (WIDTH_SEGMENTS-1) ){
					fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j+1].points[k+1].x,
								hair->strands[i].joints[j+1].points[k+1].y, 
								hair->strands[i].joints[j+1].points[k+1].z );
				}else{
					fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j+1].points[0].x,
								hair->strands[i].joints[j+1].points[0].y, 
								hair->strands[i].joints[j+1].points[0].z );
				}
				if( k != (WIDTH_SEGMENTS-1) ){
					fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j].points[k+1].x,
								hair->strands[i].joints[j].points[k+1].y, 
								hair->strands[i].joints[j].points[k+1].z );
				}else{
					fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j].points[0].x,
								hair->strands[i].joints[j].points[0].y, 
								hair->strands[i].joints[j].points[0].z );
				}
				fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[j].points[k].x,
							hair->strands[i].joints[j].points[k].y, 
							hair->strands[i].joints[j].points[k].z );
			}
		}
	}

	printf( "%d\n", count );
	j=0;
	for(i=1; i<=count; i+=6){
		fprintf( fp, "f %ld %ld %ld\n", (i+0), (i+1), (i+2) );
		fprintf( fp, "f %ld %ld %ld\n", (i+3), (i+4), (i+5) );
	j+=2;	
	}
	printf("%d faces written.\n",j);

	for(i=0; i<NUM_HAIRS; ++i ){
		for(k=0; k<WIDTH_SEGMENTS; ++k ){
			fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[0].points[k].x,
						hair->strands[i].joints[0].points[k].y,
						hair->strands[i].joints[0].points[k].z );
		}
		fprintf( fp, "f" );
		for(k=0; k<WIDTH_SEGMENTS; ++k ){
			fprintf( fp, " %d", (k+1) );
		}
		fprintf( fp, "\n" );

		for(k=0; k<WIDTH_SEGMENTS; ++k ){
			fprintf( fp, "v %f %f %f\n", hair->strands[i].joints[LENGTH_SEGMENTS-1].points[k].x,
						hair->strands[i].joints[LENGTH_SEGMENTS-1].points[k].y,
						hair->strands[i].joints[LENGTH_SEGMENTS-1].points[k].z );
		}
		fprintf( fp, "f" );
		for(k=WIDTH_SEGMENTS-1; k>=0; --k ){
			fprintf( fp, " %d", (k+1) );
		}
		fprintf( fp, "\n" );
	}

	fclose( fp );
}

