#ifndef HAIR_H
#define HAIR_H

#include "3d.h"

#define RADIUS   0.05
#define LENGTH   500.0
#define LENGTH_SEGMENTS 5
#define WIDTH_SEGMENTS  5
#define NORMAL_LENGTH   (LENGTH / LENGTH_SEGMENTS)

#define SPACING   3
#define NUM_HAIRS 500

#define DAMPING 0.97
#define GRAVITY -0.8;

#define PI 3.1415926
#define SQR(x) ( (x) * (x) )

typedef struct point_tag{
  float x, y, z;
} Point;

typedef struct joint_tag{
        float x, y, z;
        float vx, vy, vz;
        char fixed;
        Point points[ WIDTH_SEGMENTS ];
} Joint;

typedef struct strand_tag{
        float x, y, z;
        Joint joints[ LENGTH_SEGMENTS ];
} Strand;

typedef struct hair_tag{
	float x, y, z;
        Strand strands[ NUM_HAIRS ];
} Hair;

Hair *MakeHair( float x, float y, float z );
void MakeStrand( float x, float y, float z, Strand *strand );
void AnimateHair( Hair *hair, float t );
void OutputHair( char *filename, Hair *hair );
void DrawHair( Hair *hair, Camera *camera, Image *image );

#endif
