/************************************
* next step: create a function that *
* calculates all vertex normals.    *
************************************/

#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#include <time.h>
#include "3d.h"  
#include "graphics.h" 
#include "hair.h"

extern "C" {
	#include "libsx.h"
	#include "main.h"
	#include "callbacks.h"
}

#include "buttons.h"

#define XDIST 40

/** have to make it global cause how else could i draw it from move_donut?? */
MyProgram mydata;

void CreateGradient( paletteType *pal, int start, int end, int r1, int g1, int b1, int r2, int g2, int b2 );

typedef struct hairhold_tag{
	Hair *hair;
} HairHold;


Camera *camera;


void move_hair(float t, void *data){
	HairHold *hair=data;
	static frame=0;

	++frame;

	camera->position->z += 1.0;

	AnimateHair( hair->hair, t );
	DrawHair( hair->hair, camera, mydata.image );

	if( frame == 230 ){
		OutputHair( "hair.obj", hair->hair );
	}
}



void main(int argc, char **argv)
{
  HairHold hair;

  camera = MakeCamera();

  srand( time( NULL ) );

  hair.hair = MakeHair( 100.0, 200.0, 0.5 );

  mydata.image = new Image;

  mydata.image->width = 640;
  mydata.image->height = 400;
  mydata.image->bitmap = (unsigned char *)new char[mydata.image->width*mydata.image->height];


  AddObjectToList(&hair, move_hair, 1, 0, 1.0, sizeof(HairHold));

  init_display(argc, argv, &mydata);

  MainLoop();
}


void CreateGradient( paletteType *pal, int start, int end, int r1, int g1, int b1, int r2, int g2, int b2 ){
	int i;

	for(i = start; i <= end; i++){
		pal->r[i] = (int)( ( (i-start)/(float)(end-start) ) * ( r2 - r1 ) + r1 );
		pal->g[i] = (int)( ( (i-start)/(float)(end-start) ) * ( g2 - g1 ) + g1 );
		pal->b[i] = (int)( ( (i-start)/(float)(end-start) ) * ( b2 - b1 ) + b1 );
	}
}

void init_display(int argc, char **argv, MyProgram *me)
{
  int i,maxcolor;
  Widget w[9];

  if (OpenDisplay(argc, argv) == FALSE)
    return;

  w[0] = MakeButton("Quit!", quit, me);
  w[1] = MakeLabel("Donut Demo");
  w[2] = MakeDrawArea(me->image->width + 1, me->image->height  + 1, redisplay, me);
  w[3] = MakeButton("Rewind", rewind_anim, me);
  w[4] = MakeButton("Stop", stop_anim, me);
  w[5] = MakeButton("Play", play_anim, me);
  w[6] = MakeButton("Foward", forward_anim, me);
  w[7] = MakeButton("Repeat", repeat_anim, me);
  w[8] = MakeHorizScrollbar(me->image->width - 150, scroll, me);
//  w[9] = MakeLabel("t = 0.00");

  /*
   * These callbacks are unnecessary for most applications, but
   * they're here for completeness.  Remove them if you don't
   * need them.
   */
  SetButtonDownCB(w[3],  button_down);
  SetButtonUpCB(w[3],    button_up);
  SetKeypressCB(w[3],    keypress);
  SetMouseMotionCB(w[3], motion);

  SetWidgetPos(w[1], PLACE_RIGHT, w[0], NO_CARE, NULL);
  SetWidgetPos(w[2], PLACE_UNDER, w[1], NO_CARE, NULL);
  SetWidgetPos(w[3], PLACE_UNDER, w[2], NO_CARE, NULL);
  SetWidgetPos(w[4], PLACE_UNDER, w[2], PLACE_RIGHT, w[3]);
  SetWidgetPos(w[5], PLACE_UNDER, w[2], PLACE_RIGHT, w[4]);
  SetWidgetPos(w[6], PLACE_UNDER, w[2], PLACE_RIGHT, w[5]);
  SetWidgetPos(w[7], PLACE_UNDER, w[2], PLACE_RIGHT, w[6]);
  SetWidgetPos(w[8], PLACE_UNDER, w[2], PLACE_RIGHT, w[7]);
//  SetWidgetPos(w[9], PLACE_UNDER, w[8], PLACE_RIGHT, w[7]);

  SetWidgetBitmap(w[3], (char *)rewind_bits, rewind_width, rewind_height);
  SetWidgetBitmap(w[4], (char *)stop_bits, stop_width, stop_height);
  SetWidgetBitmap(w[5], (char *)play_bits, play_width, play_height);
  SetWidgetBitmap(w[6], (char *)forward_bits, forward_width, forward_height);
  SetWidgetBitmap(w[7], (char *)repeat_bits, repeat_width, repeat_height);

  me->repeat_widget = w[7];
  me->scroll_widget = w[8];
  me->label_widget = w[9];


  SetScrollbar(w[8], 50.0, 100.0, 1.0);
 
  /* This call actually causes the whole thing to be displayed on the
   * screen.  You have to call this function before doing any drawing
   * into the window.
   */
  ShowDisplay();

  
  /* Get standard (red, blue, green, yellow, black, white) colors for
   * drawing stuff.  Check libsx.h for more info. 
   */
  
  GetStandardColors();
//  SetColorMap(GREY_SCALE_2);

  me->pal.r[0] = me->pal.g[0] = me->pal.b[0] = 0;

  CreateGradient( &(me->pal), 0, 255,   0, 0, 0,     193, 153, 27 );   

  SetMyColorMap(256, me->pal.r, me->pal.g, me->pal.b);

   /*
   * You can wait to do it till later if you want.  There's no need 
   * to do it here if you don't need to (because it wacks out the
   * colormap).  
   */

  SetupAnimation(START_LATER, 0.0, T_INC, T_DELAY, FORWARD, (GeneralCB) animate, me);
  repeat_anim(me->repeat_widget, me);
}




